#!/usr/bin/perl

# 99 Bottles of Beer
# 
# Zusätzlich auswerten der Kommandozeile
use strict;
use warnings;


my %config = (count => 3,
              drink => "beer",
             );

# Default-Werte aus Datei laden (wenn vorhanden)
if(open(my $cfh, "bottles5.conf")) {
    while(my $line = <$cfh>) {
        # \n wegmachen
        chomp $line;

        # Kommentare ignorieren
        next if($line =~ /^#/);

        # Nur verwertbare Zeilen auswerten
        if($line =~ /^(.*)=(.*)/o) {
            $config{$1} = $2;
        }
    }
    close $cfh;
}

# Auswerten der kommandozeilen-Argumente
foreach my $arg (@ARGV) {
    if($arg =~/^--(.*)=(.*)/) {
        $config{$1} = $2;
    }
}

my $count = $config{"count"};
my $drink = $config{"drink"};

# Zeilen aus Datei laden
open(my $fh, "bottles5.dat") or die("Can't open bottles5.dat");
my @lines = <$fh>;
close $fh;

while($count) {
    my $tempcount = $count - 1;
    foreach my $origline (@lines) {
        my $line = $origline;
        $line =~ s/__COUNT__/$count/g;
        $line =~ s/__COUNTLESS__/$tempcount/g;
        $line =~ s/__DRINK__/$drink/g;
        print $line;
    }
    $count--;
}

print "ERROR 007: Out of bottles!\n";
